#include "FISClass.h"
#include <stdio.h>
#include <stdlib.h>

double FuzzyGraph(char *FisFile, int NInputs, double *Inputs);

JNIEXPORT jdouble JNICALL Java_FISClass_getAnswer
(JNIEnv * env, jobject this, jstring fname, jdoubleArray parray) {

  int NInputs;
  jdouble* Inputs;
  double Answer;

  int count;

  /* create a fis file using Matlab software */
  static char FisFileName[80]="./acceleration.fis";

  /* get the file name */
  const char *str = (*env)->GetStringUTFChars(env, fname, 0);

  /* get the array for the arguments */  
  NInputs = (*env)->GetArrayLength(env, parray);
  Inputs = (*env)->GetDoubleArrayElements(env, parray, 0);

  /* for (count = 0; count < NInputs; count++)
    printf ("input %d = %f\n", count, Inputs[count]); */

  strcpy (FisFileName, str);
  /* NInputs=2;       /* the acceleration example requires 2 inputs */
  /* Inputs[0]=80;    /* horsepower input --- domain [45-230] */
  /* Inputs[1]=5000;  /* weight input --- domain [1600-5150] */

  /* infer results based on fis file and inputs */ 
  Answer=FuzzyGraph(FisFileName, NInputs, Inputs);
  
  /* fprintf(stderr,"The Answer is %lf\n",Answer); */

  /* free memory */
  (*env)->ReleaseStringUTFChars(env, fname, str);
  (*env)->ReleaseDoubleArrayElements(env, parray, Inputs, 0);

  return Answer;
}
